diff --git a/gdb/testsuite/gdb.base/vla-optimized-out-o3-strict.exp b/gdb/testsuite/gdb.base/vla-optimized-out-o3-strict.exp
deleted file mode 100644
index 81ada875b37..00000000000
--- a/gdb/testsuite/gdb.base/vla-optimized-out-o3-strict.exp
+++ /dev/null
@@ -1,40 +0,0 @@
-# Copyright 2018 Free Software Foundation, Inc.
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-
-# Check whether we can determine the size of an optimized-out vla.
-
-standard_testfile
-
-if { [prepare_for_testing "failed to prepare" $testfile vla-optimized-out.c \
-	  {debug optimize=-O3 additional_flags=-gstrict-dwarf}] } {
-    return -1
-}
-
-proc vla_optimized_out { } {
-    if ![runto f1] {
-	fail "can't run to f1"
-	return
-    }
-
-    gdb_test "p a" \
-	{ = <optimized out>} \
-	"printed optimized out vla"
-
-    gdb_test "p sizeof (a)" \
-	{ = <optimized out>} \
-	"printed optimized out size of optimized out vla"
-}
-
-vla_optimized_out
diff --git a/gdb/testsuite/gdb.base/vla-optimized-out-o3.exp b/gdb/testsuite/gdb.base/vla-optimized-out-o3.exp
deleted file mode 100644
index 60707e7aff8..00000000000
--- a/gdb/testsuite/gdb.base/vla-optimized-out-o3.exp
+++ /dev/null
@@ -1,36 +0,0 @@
-# Copyright 2018 Free Software Foundation, Inc.
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-
-# Check whether we can print an optimized-out vla.
-
-standard_testfile
-
-if { [prepare_for_testing "failed to prepare" $testfile "vla-optimized-out.c" \
-	  {debug optimize=-O3}] } {
-    return -1
-}
-
-proc vla_optimized_out { } {
-    if ![runto f1] {
-	fail "can't run to f1"
-	return
-    }
-
-    gdb_test "p a" \
-	{ = <optimized out>} \
-	"printed optimized out vla"
-}
-
-vla_optimized_out
diff --git a/gdb/testsuite/gdb.base/vla-optimized-out.exp b/gdb/testsuite/gdb.base/vla-optimized-out.exp
index b27569ed1e1..fa521765969 100644
--- a/gdb/testsuite/gdb.base/vla-optimized-out.exp
+++ b/gdb/testsuite/gdb.base/vla-optimized-out.exp
@@ -17,24 +17,46 @@
 
 standard_testfile
 
-if { [prepare_for_testing "failed to prepare" $testfile $srcfile \
-	  {debug optimize=-O1 additional_flags=-DNOCLONE}] } {
-    return -1
-}
+proc vla_optimized_out {compile_flags exe_suffix sizeof_result} {
+    global testfile srcfile
+
+    if { [prepare_for_testing "failed to prepare" "$testfile-$exe_suffix" $srcfile \
+	      $compile_flags] } {
+	return -1
+    }
 
-proc vla_optimized_out { } {
     if ![runto f1] {
 	fail "can't run to f1"
 	return
     }
 
     gdb_test "p a" \
-	{ = <optimized out>} \
+	" = <optimized out>" \
 	"printed optimized out vla"
 
     gdb_test "p sizeof (a)" \
-	{ = 6} \
+	" = $sizeof_result" \
 	"printed size of optimized out vla"
 }
 
-vla_optimized_out
+foreach test_settings [list \
+			   [list "o1" \
+				{debug optimize=-O1 \
+				     additional_flags=-DNOCLONE} \
+				"6"] \
+			   [list "o3" \
+				{debug optimize=-O3} \
+				"<optimized out>"]\
+			   [list "o3_strict" \
+				{debug optimize=-O3 \
+				     additional_flags=-gstrict-dwarf} \
+				"<optimized out>"]] {
+    set test_prefix [lindex $test_settings 0]
+    set compile_flags [lindex $test_settings 1]
+    set sizeof_result [lindex $test_settings 2]
+
+    with_test_prefix $test_prefix {
+	vla_optimized_out $compile_flags $test_prefix $sizeof_result
+    }
+}
+